//+------------------------------------------------------------------+
//|                                                    ThreeMACD.mq4 |
//|                                                             troi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "troi"
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       m11=34;
extern int       m12=144;
extern int       m13=1;
extern int       m21=21;
extern int       m22=34;
extern int       m23=1;
extern int       m31=13;
extern int       m32=21;
extern int       m33=1;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
 if(IsExistPosition()) return(0);
 int k=main_func();
 switch(k)
 {
   case 1:                    
           double takeprofit=Ask+70*Point;
           double stoploss=Ask-25*Point;
           double Lot=0.1;
           OrderSend(Symbol(), OP_BUY, Lot, Ask, 3, stoploss, takeprofit);
         break;
   case -1:
           takeprofit=Bid-70*Point;
           stoploss=Bid+25*Point;
           Lot=0.1;
           OrderSend(Symbol(), OP_SELL, Lot, Bid, 3, stoploss, takeprofit);   
         break;
   default:
         break;
 }
//----
   return(0);
}
//+------------------------------------------------------------------+
//  1    , -1    , 0 -   
int main_func()
{ 
 static double m1_old=0;
 static double m2_old=0;
 static double m3_old=0;
 int f=0;
 
 double m1=iMACD(Symbol(), Period(), m11, m12, m13, PRICE_HIGH, MODE_SIGNAL,0);
 double m2=iMACD(Symbol(), Period(), m21, m22, m23, PRICE_HIGH, MODE_SIGNAL,0);
 double m3=iMACD(Symbol(), Period(), m31, m32, m33, PRICE_HIGH, MODE_SIGNAL,0);
 
 if(IsNeedSell(m1, m2, m3, m3_old)) f=-1; //ok
 if(IsNeedSell(m2, m3, m1, m1_old)) f=-1; //ok
 if(IsNeedSell(m3, m1, m2, m2_old)) f=-1;
 
 if(IsNeedBuy(m1, m2, m3, m3_old)) f=1;
 if(IsNeedBuy(m2, m3, m1, m1_old)) f=1;
 if(IsNeedBuy(m3, m1, m2, m2_old)) f=1;
 
 m1_old=m1;
 m2_old=m2;
 m3_old=m3;
 return(f);
}
//+------------------------------------------------------------------+
bool IsNeedSell(double macd1, double macd2, double macd3, double macd3_old)
{
 if(macd1<0 && macd2<0 && macd3_old>0 && macd3<0) return(true);
 return(false);
} 
//+------------------------------------------------------------------+

bool IsNeedBuy(double macd1, double macd2, double macd3, double macd3_old)
{
 if(macd1>0 && macd2>0 && macd3_old<0 && macd3>0) return(true);
 return(false);
} 
//+------------------------------------------------------------------+
//   true,       . 
bool IsExistPosition()
{   
   //,         inform
   int total=OrdersTotal();
   for(int i=total-1; i>=0; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
         if(OrderSymbol()==Symbol()) return(true);
   }
      
   return(false);
}
//+------------------------------------------------------------------+